RemappingMethodAdapter (ASM 5.0.4 Documentation)
Date: 2015-09-18

org.objectweb.asm.commons

## Class RemappingMethodAdapter

- java.lang.Object
- - org.objectweb.asm.MethodVisitor
  - - org.objectweb.asm.commons.LocalVariablesSorter
    - - org.objectweb.asm.commons.RemappingMethodAdapter

-     public class RemappingMethodAdapter
      extends LocalVariablesSorter

  A `LocalVariablesSorter` for type mapping.
  Author:
    Eugene Kuleshov

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Remapper` | `remapper`

    - ### Fields inherited from class org.objectweb.asm.commons.LocalVariablesSorter

      `firstLocal, nextLocal`

    - ### Fields inherited from class org.objectweb.asm.MethodVisitor

      `api, mv`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `RemappingMethodAdapter(int api, int access, String desc, MethodVisitor mv, Remapper remapper)`
    `` | `RemappingMethodAdapter(int access, String desc, MethodVisitor mv, Remapper remapper)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AnnotationVisitor` | `visitAnnotation(String desc, boolean visible)` Visits an annotation of this method.
    `AnnotationVisitor` | `visitAnnotationDefault()` Visits the default value of this annotation interface method.
    `void` | `visitFieldInsn(int opcode, String owner, String name, String desc)` Visits a field instruction.
    `void` | `visitFrame(int type, int nLocal, Object[] local, int nStack, Object[] stack)` Visits the current state of the local variables and operand stack elements.
    `AnnotationVisitor` | `visitInsnAnnotation(int typeRef, TypePath typePath, String desc, boolean visible)` Visits an annotation on an instruction.
    `void` | `visitInvokeDynamicInsn(String name, String desc, Handle bsm, Object... bsmArgs)` Visits an invokedynamic instruction.
    `void` | `visitLdcInsn(Object cst)` Visits a LDC instruction.
    `void` | `visitLocalVariable(String name, String desc, String signature, Label start, Label end, int index)` Visits a local variable declaration.
    `AnnotationVisitor` | `visitLocalVariableAnnotation(int typeRef, TypePath typePath, Label[] start, Label[] end, int[] index, String desc, boolean visible)` Visits an annotation on a local variable type.
    `void` | `visitMethodInsn(int opcode, String owner, String name, String desc)` Deprecated.
    `void` | `visitMethodInsn(int opcode, String owner, String name, String desc, boolean itf)` Visits a method instruction.
    `void` | `visitMultiANewArrayInsn(String desc, int dims)` Visits a MULTIANEWARRAY instruction.
    `AnnotationVisitor` | `visitParameterAnnotation(int parameter, String desc, boolean visible)` Visits an annotation of a parameter this method.
    `AnnotationVisitor` | `visitTryCatchAnnotation(int typeRef, TypePath typePath, String desc, boolean visible)` Visits an annotation on an exception handler type.
    `void` | `visitTryCatchBlock(Label start, Label end, Label handler, String type)` Visits a try catch block.
    `AnnotationVisitor` | `visitTypeAnnotation(int typeRef, TypePath typePath, String desc, boolean visible)` Visits an annotation on a type in the method signature.
    `void` | `visitTypeInsn(int opcode, String type)` Visits a type instruction.

    - ### Methods inherited from class org.objectweb.asm.commons.LocalVariablesSorter

      `newLocal, newLocalMapping, setLocalType, updateNewLocals, visitIincInsn, visitMaxs, visitVarInsn`

    - ### Methods inherited from class org.objectweb.asm.MethodVisitor

      `visitAttribute, visitCode, visitEnd, visitInsn, visitIntInsn, visitJumpInsn, visitLabel, visitLineNumber, visitLookupSwitchInsn, visitParameter, visitTableSwitchInsn`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### remapper

          protected final Remapper remapper

  - ### Constructor Detail

    - #### RemappingMethodAdapter

          public RemappingMethodAdapter(int access,
                                String desc,
                                MethodVisitor mv,
                                Remapper remapper)

    - #### RemappingMethodAdapter

          protected RemappingMethodAdapter(int api,
                                int access,
                                String desc,
                                MethodVisitor mv,
                                Remapper remapper)

  - ### Method Detail

    - #### visitAnnotationDefault

          public AnnotationVisitor visitAnnotationDefault()

      Description copied from class: `MethodVisitor`
      Visits the default value of this annotation interface method.
      Overrides:
        `visitAnnotationDefault` in class `MethodVisitor`
      Returns:
        a visitor to the visit the actual default value of this annotation interface method, or `null` if this visitor is not interested in visiting this default value. The 'name' parameters passed to the methods of this annotation visitor are ignored. Moreover, exacly one visit method must be called on this annotation visitor, followed by visitEnd.

    - #### visitAnnotation

          public AnnotationVisitor visitAnnotation(String desc,
                                          boolean visible)

      Description copied from class: `MethodVisitor`
      Visits an annotation of this method.
      Overrides:
        `visitAnnotation` in class `MethodVisitor`
      Parameters:
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitTypeAnnotation

          public AnnotationVisitor visitTypeAnnotation(int typeRef,
                                              TypePath typePath,
                                              String desc,
                                              boolean visible)

      Description copied from class: `MethodVisitor`
      Visits an annotation on a type in the method signature.
      Overrides:
        `visitTypeAnnotation` in class `MethodVisitor`
      Parameters:
        `typeRef` - a reference to the annotated type. The sort of this type reference must be `METHOD_TYPE_PARAMETER`, `METHOD_TYPE_PARAMETER_BOUND`, `METHOD_RETURN`, `METHOD_RECEIVER`, `METHOD_FORMAL_PARAMETER` or `THROWS`. See `TypeReference`.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be `null` if the annotation targets 'typeRef' as a whole.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitParameterAnnotation

          public AnnotationVisitor visitParameterAnnotation(int parameter,
                                                   String desc,
                                                   boolean visible)

      Description copied from class: `MethodVisitor`
      Visits an annotation of a parameter this method.
      Overrides:
        `visitParameterAnnotation` in class `MethodVisitor`
      Parameters:
        `parameter` - the parameter index.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitFrame

          public void visitFrame(int type,
                        int nLocal,
                        Object[] local,
                        int nStack,
                        Object[] stack)

      Description copied from class: `MethodVisitor`
      Visits the current state of the local variables and operand stack elements. This method must(*) be called just before any instruction i that follows an unconditional branch instruction such as GOTO or THROW, that is the target of a jump instruction, or that starts an exception handler block. The visited types must describe the values of the local variables and of the operand stack elements just before i is executed.
      (*) this is mandatory only for classes whose version is greater than or equal to `V1_6`.
      The frames of a method must be given either in expanded form, or in compressed form (all frames must use the same format, i.e. you must not mix expanded and compressed frames within a single method):
      - In expanded form, all frames must have the F_NEW type.
      - In compressed form, frames are basically "deltas" from the state of the previous frame:
        - `Opcodes.F_SAME` representing frame with exactly the same locals as the previous frame and with the empty stack.
        - `Opcodes.F_SAME1` representing frame with exactly the same locals as the previous frame and with single value on the stack ( `nStack` is 1 and `stack[0]` contains value for the type of the stack item).
        - `Opcodes.F_APPEND` representing frame with current locals are the same as the locals in the previous frame, except that additional locals are defined (`nLocal` is 1, 2 or 3 and `local` elements contains values representing added types).
        - `Opcodes.F_CHOP` representing frame with current locals are the same as the locals in the previous frame, except that the last 1-3 locals are absent and with the empty stack (`nLocals` is 1, 2 or 3).
        - `Opcodes.F_FULL` representing complete frame data.
      In both cases the first frame, corresponding to the method's parameters and access flags, is implicit and must not be visited. Also, it is illegal to visit two or more frames for the same code location (i.e., at least one instruction must be visited between two calls to visitFrame).
      Overrides:
        `visitFrame` in class `LocalVariablesSorter`
      Parameters:
        `type` - the type of this stack map frame. Must be `Opcodes.F_NEW` for expanded frames, or `Opcodes.F_FULL`, `Opcodes.F_APPEND`, `Opcodes.F_CHOP`, `Opcodes.F_SAME` or `Opcodes.F_APPEND`, `Opcodes.F_SAME1` for compressed frames.
        `nLocal` - the number of local variables in the visited frame.
        `local` - the local variable types in this frame. This array must not be modified. Primitive types are represented by `Opcodes.TOP`, `Opcodes.INTEGER`, `Opcodes.FLOAT`, `Opcodes.LONG`, `Opcodes.DOUBLE`,`Opcodes.NULL` or `Opcodes.UNINITIALIZED_THIS` (long and double are represented by a single element). Reference types are represented by String objects (representing internal names), and uninitialized types by Label objects (this label designates the NEW instruction that created this uninitialized value).
        `nStack` - the number of operand stack elements in the visited frame.
        `stack` - the operand stack types in this frame. This array must not be modified. Its content has the same format as the "local" array.

    - #### visitFieldInsn

          public void visitFieldInsn(int opcode,
                            String owner,
                            String name,
                            String desc)

      Description copied from class: `MethodVisitor`
      Visits a field instruction. A field instruction is an instruction that loads or stores the value of a field of an object.
      Overrides:
        `visitFieldInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either GETSTATIC, PUTSTATIC, GETFIELD or PUTFIELD.
        `owner` - the internal name of the field's owner class (see `getInternalName`).
        `name` - the field's name.
        `desc` - the field's descriptor (see `Type`).

    - #### visitMethodInsn

          @Deprecated
          public void visitMethodInsn(int opcode,
                                        String owner,
                                        String name,
                                        String desc)

      Deprecated.
      Description copied from class: `MethodVisitor`
      Visits a method instruction. A method instruction is an instruction that invokes a method.
      Overrides:
        `visitMethodInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either INVOKEVIRTUAL, INVOKESPECIAL, INVOKESTATIC or INVOKEINTERFACE.
        `owner` - the internal name of the method's owner class (see `getInternalName`).
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).

    - #### visitMethodInsn

          public void visitMethodInsn(int opcode,
                             String owner,
                             String name,
                             String desc,
                             boolean itf)

      Description copied from class: `MethodVisitor`
      Visits a method instruction. A method instruction is an instruction that invokes a method.
      Overrides:
        `visitMethodInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either INVOKEVIRTUAL, INVOKESPECIAL, INVOKESTATIC or INVOKEINTERFACE.
        `owner` - the internal name of the method's owner class (see `getInternalName`).
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `itf` - if the method's owner class is an interface.

    - #### visitInvokeDynamicInsn

          public void visitInvokeDynamicInsn(String name,
                                    String desc,
                                    Handle bsm,
                                    Object... bsmArgs)

      Description copied from class: `MethodVisitor`
      Visits an invokedynamic instruction.
      Overrides:
        `visitInvokeDynamicInsn` in class `MethodVisitor`
      Parameters:
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `bsm` - the bootstrap method.
        `bsmArgs` - the bootstrap method constant arguments. Each argument must be an `Integer`, `Float`, `Long`, `Double`, `String`, `Type` or `Handle` value. This method is allowed to modify the content of the array so a caller should expect that this array may change.

    - #### visitTypeInsn

          public void visitTypeInsn(int opcode,
                           String type)

      Description copied from class: `MethodVisitor`
      Visits a type instruction. A type instruction is an instruction that takes the internal name of a class as parameter.
      Overrides:
        `visitTypeInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either NEW, ANEWARRAY, CHECKCAST or INSTANCEOF.
        `type` - the operand of the instruction to be visited. This operand must be the internal name of an object or array class (see `getInternalName`).

    - #### visitLdcInsn

          public void visitLdcInsn(Object cst)

      Description copied from class: `MethodVisitor`
      Visits a LDC instruction. Note that new constant types may be added in future versions of the Java Virtual Machine. To easily detect new constant types, implementations of this method should check for unexpected constant types, like this:

           if (cst instanceof Integer) {
               // ...
           } else if (cst instanceof Float) {
               // ...
           } else if (cst instanceof Long) {
               // ...
           } else if (cst instanceof Double) {
               // ...
           } else if (cst instanceof String) {
               // ...
           } else if (cst instanceof Type) {
               int sort = ((Type) cst).getSort();
               if (sort == Type.OBJECT) {
                   // ...
               } else if (sort == Type.ARRAY) {
                   // ...
               } else if (sort == Type.METHOD) {
                   // ...
               } else {
                   // throw an exception
               }
           } else if (cst instanceof Handle) {
               // ...
           } else {
               // throw an exception
           }

      Overrides:
        `visitLdcInsn` in class `MethodVisitor`
      Parameters:
        `cst` - the constant to be loaded on the stack. This parameter must be a non null `Integer`, a `Float`, a `Long`, a `Double`, a `String`, a `Type` of OBJECT or ARRAY sort for `.class` constants, for classes whose version is 49.0, a `Type` of METHOD sort or a `Handle` for MethodType and MethodHandle constants, for classes whose version is 51.0.

    - #### visitMultiANewArrayInsn

          public void visitMultiANewArrayInsn(String desc,
                                     int dims)

      Description copied from class: `MethodVisitor`
      Visits a MULTIANEWARRAY instruction.
      Overrides:
        `visitMultiANewArrayInsn` in class `MethodVisitor`
      Parameters:
        `desc` - an array type descriptor (see `Type`).
        `dims` - number of dimensions of the array to allocate.

    - #### visitInsnAnnotation

          public AnnotationVisitor visitInsnAnnotation(int typeRef,
                                              TypePath typePath,
                                              String desc,
                                              boolean visible)

      Description copied from class: `MethodVisitor`
      Visits an annotation on an instruction. This method must be called just after the annotated instruction. It can be called several times for the same instruction.
      Overrides:
        `visitInsnAnnotation` in class `MethodVisitor`
      Parameters:
        `typeRef` - a reference to the annotated type. The sort of this type reference must be `INSTANCEOF`, `NEW`, `CONSTRUCTOR_REFERENCE`, `METHOD_REFERENCE`, `CAST`, `CONSTRUCTOR_INVOCATION_TYPE_ARGUMENT`, `METHOD_INVOCATION_TYPE_ARGUMENT`, `CONSTRUCTOR_REFERENCE_TYPE_ARGUMENT`, or `METHOD_REFERENCE_TYPE_ARGUMENT`. See `TypeReference`.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be `null` if the annotation targets 'typeRef' as a whole.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitTryCatchBlock

          public void visitTryCatchBlock(Label start,
                                Label end,
                                Label handler,
                                String type)

      Description copied from class: `MethodVisitor`
      Visits a try catch block.
      Overrides:
        `visitTryCatchBlock` in class `MethodVisitor`
      Parameters:
        `start` - beginning of the exception handler's scope (inclusive).
        `end` - end of the exception handler's scope (exclusive).
        `handler` - beginning of the exception handler's code.
        `type` - internal name of the type of exceptions handled by the handler, or `null` to catch any exceptions (for "finally" blocks).

    - #### visitTryCatchAnnotation

          public AnnotationVisitor visitTryCatchAnnotation(int typeRef,
                                                  TypePath typePath,
                                                  String desc,
                                                  boolean visible)

      Description copied from class: `MethodVisitor`
      Visits an annotation on an exception handler type. This method must be called after the `MethodVisitor.visitTryCatchBlock(org.objectweb.asm.Label, org.objectweb.asm.Label, org.objectweb.asm.Label, java.lang.String)` for the annotated exception handler. It can be called several times for the same exception handler.
      Overrides:
        `visitTryCatchAnnotation` in class `MethodVisitor`
      Parameters:
        `typeRef` - a reference to the annotated type. The sort of this type reference must be `EXCEPTION_PARAMETER`. See `TypeReference`.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be `null` if the annotation targets 'typeRef' as a whole.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitLocalVariable

          public void visitLocalVariable(String name,
                                String desc,
                                String signature,
                                Label start,
                                Label end,
                                int index)

      Description copied from class: `MethodVisitor`
      Visits a local variable declaration.
      Overrides:
        `visitLocalVariable` in class `LocalVariablesSorter`
      Parameters:
        `name` - the name of a local variable.
        `desc` - the type descriptor of this local variable.
        `signature` - the type signature of this local variable. May be `null` if the local variable type does not use generic types.
        `start` - the first instruction corresponding to the scope of this local variable (inclusive).
        `end` - the last instruction corresponding to the scope of this local variable (exclusive).
        `index` - the local variable's index.

    - #### visitLocalVariableAnnotation

          public AnnotationVisitor visitLocalVariableAnnotation(int typeRef,
                                                       TypePath typePath,
                                                       Label[] start,
                                                       Label[] end,
                                                       int[] index,
                                                       String desc,
                                                       boolean visible)

      Description copied from class: `MethodVisitor`
      Visits an annotation on a local variable type.
      Overrides:
        `visitLocalVariableAnnotation` in class `LocalVariablesSorter`
      Parameters:
        `typeRef` - a reference to the annotated type. The sort of this type reference must be `LOCAL_VARIABLE` or `RESOURCE_VARIABLE`. See `TypeReference`.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be `null` if the annotation targets 'typeRef' as a whole.
        `start` - the fist instructions corresponding to the continuous ranges that make the scope of this local variable (inclusive).
        `end` - the last instructions corresponding to the continuous ranges that make the scope of this local variable (exclusive). This array must have the same size as the 'start' array.
        `index` - the local variable's index in each range. This array must have the same size as the 'start' array.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.